package com.example.javaee.model;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;
import java.util.Set;

/**
 * The Author entity.
 * @author Matus
 *
 * TODO: make this a DB entity with table name B_AUTHOR with auto generated LONG ID.
 * TODO: we want to track creation/update date of this entity
 *
 */
@Getter
@Setter
public class Author extends TraceAble {

    //TODO make me an autogenerated PK
    private Long id;

    private String name;

    // TODO store this as DB DATE not TIMESTAMP(hint: google Hibernate Temporal)
    private Date dateOfBirth;

    // TODO: should not be stored in DB obviously, but calculated when loaded - currDate - dateOfBirth / ms_in_year
    //  Hint: google Hibernate transient
    private long age;

    // TODO: do not load eagerly,
    // TODO: we want a FK column in the Book table named 'AUTHOR_ID'
    // TODO: make it possible to assign book to author by saving author
    //  Hint: google Hibernate cascade, mappedBy
    private Set<Book> books;

    // TODO: all columns from Address should be included in the author table
    //  Hint: google Hibernate embeddable
    private Address address;


    // TODO use this to calculate the age after load from DB
    //  Hint: what would be a correct lifecycle event listener to bind this to?
    //  Hint: google hibernate entity lifecycle events
    public void calcAge() {
        this.age = (new Date().getTime() - this.dateOfBirth.getTime()) / (1000 * 60 * 60 * 24 * 365);
    }
}
